"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const crossProduct = require("./crossProduct.js");
function computeCrossProduct(polygon, start, length) {
  const x1 = polygon[start];
  const y1 = polygon[start + 1];
  const j = (start + 2) % length;
  const x2 = polygon[j];
  const y2 = polygon[j + 1];
  const k = (start + 4) % length;
  const x3 = polygon[k];
  const y3 = polygon[k + 1];
  return crossProduct.crossProduct(x1, y1, x2, y2, x3, y3);
}
function isConvexPolygon(polygon) {
  const { length } = polygon;
  if (length < 6 || length % 2 !== 0) {
    return false;
  }
  const direction = computeCrossProduct(polygon, 0, length);
  for (let i = 2; i < length; i += 2) {
    const nextDirection = computeCrossProduct(polygon, i, length);
    if (direction * nextDirection <= 0) {
      return false;
    }
  }
  return true;
}
exports.isConvexPolygon = isConvexPolygon;
